// SPDX-License-Identifier: Apache-2.0
// Copyright Authors of Cilium

package resource

import (
	// Imports for Envoy extensions not used directly from Cilium Agent, but that we want to
	// be registered for use in Cilium Envoy Config CRDs. This can be used for any downstream
	// project that wants to use Cilium Envoy Config CRDs to generate Envoy configs.
	_ "github.com/cilium/proxy/go/envoy/admin/v3"
	_ "github.com/cilium/proxy/go/envoy/annotations"
	_ "github.com/cilium/proxy/go/envoy/config/accesslog/v3"
	_ "github.com/cilium/proxy/go/envoy/config/bootstrap/v3"
	_ "github.com/cilium/proxy/go/envoy/config/cluster/redis"
	_ "github.com/cilium/proxy/go/envoy/config/cluster/v3"
	_ "github.com/cilium/proxy/go/envoy/config/common/key_value/v3"
	_ "github.com/cilium/proxy/go/envoy/config/common/matcher/v3"
	_ "github.com/cilium/proxy/go/envoy/config/common/mutation_rules/v3"
	_ "github.com/cilium/proxy/go/envoy/config/core/v3"
	_ "github.com/cilium/proxy/go/envoy/config/endpoint/v3"
	_ "github.com/cilium/proxy/go/envoy/config/grpc_credential/v3"
	_ "github.com/cilium/proxy/go/envoy/config/listener/v3"
	_ "github.com/cilium/proxy/go/envoy/config/metrics/v3"
	_ "github.com/cilium/proxy/go/envoy/config/overload/v3"
	_ "github.com/cilium/proxy/go/envoy/config/ratelimit/v3"
	_ "github.com/cilium/proxy/go/envoy/config/rbac/v3"
	_ "github.com/cilium/proxy/go/envoy/config/retry/previous_priorities"
	_ "github.com/cilium/proxy/go/envoy/config/route/v3"
	_ "github.com/cilium/proxy/go/envoy/config/tap/v3"
	_ "github.com/cilium/proxy/go/envoy/config/trace/v3"
	_ "github.com/cilium/proxy/go/envoy/config/upstream/local_address_selector/v3"
	_ "github.com/cilium/proxy/go/envoy/data/accesslog/v3"
	_ "github.com/cilium/proxy/go/envoy/data/cluster/v3"
	_ "github.com/cilium/proxy/go/envoy/data/core/v3"
	_ "github.com/cilium/proxy/go/envoy/data/dns/v3"
	_ "github.com/cilium/proxy/go/envoy/data/tap/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/access_loggers/file/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/access_loggers/filters/cel/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/access_loggers/fluentd/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/access_loggers/grpc/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/access_loggers/open_telemetry/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/access_loggers/stream/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/access_loggers/wasm/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/bootstrap/internal_listener/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/clusters/aggregate/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/clusters/dynamic_forward_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/clusters/redis/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/common/async_files/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/common/dynamic_forward_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/common/matching/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/common/ratelimit/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/common/tap/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/compression/brotli/compressor/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/compression/brotli/decompressor/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/compression/gzip/compressor/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/compression/gzip/decompressor/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/compression/zstd/compressor/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/compression/zstd/decompressor/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/config/validators/minimum_clusters/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/early_data/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/common/dependency/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/common/fault/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/common/matcher/action/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/common/set_filter_state/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/adaptive_concurrency/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/admission_control/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/alternate_protocols_cache/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/aws_lambda/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/aws_request_signing/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/bandwidth_limit/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/basic_auth/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/buffer/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/cache/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/cdn_loop/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/composite/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/compressor/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/connect_grpc_bridge/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/cors/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/credential_injector/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/csrf/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/custom_response/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/decompressor/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/dynamic_forward_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/ext_authz/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/ext_proc/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/fault/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/file_system_buffer/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/gcp_authn/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/geoip/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/grpc_field_extraction/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/grpc_http1_bridge/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/grpc_http1_reverse_bridge/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/grpc_json_transcoder/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/grpc_stats/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/grpc_web/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/gzip/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/header_mutation/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/header_to_metadata/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/health_check/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/ip_tagging/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/json_to_metadata/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/jwt_authn/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/kill_request/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/local_ratelimit/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/lua/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/oauth2/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/on_demand/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/original_src/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/proto_message_extraction/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/proto_message_logging/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/rate_limit_quota/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/ratelimit/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/rbac/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/router/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/set_filter_state/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/set_metadata/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/stateful_session/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/tap/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/thrift_to_metadata/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/upstream_codec/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/http/wasm/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/listener/http_inspector/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/listener/local_ratelimit/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/listener/original_dst/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/listener/original_src/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/listener/proxy_protocol/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/listener/tls_inspector/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/connection_limit/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/direct_response/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/dubbo_proxy/router/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/dubbo_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/echo/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/ext_authz/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/generic_proxy/action/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/generic_proxy/codecs/dubbo/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/generic_proxy/codecs/http1/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/generic_proxy/matcher/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/generic_proxy/router/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/generic_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/http_connection_manager/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/local_ratelimit/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/mongo_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/ratelimit/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/rbac/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/redis_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/set_filter_state/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/sni_cluster/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/sni_dynamic_forward_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/tcp_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/thrift_proxy/filters/header_to_metadata/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/thrift_proxy/filters/payload_to_metadata/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/thrift_proxy/filters/ratelimit/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/thrift_proxy/router/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/thrift_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/wasm/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/network/zookeeper_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/udp/dns_filter/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/udp/udp_proxy/session/dynamic_forward_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/udp/udp_proxy/session/http_capsule/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/filters/udp/udp_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/formatter/cel/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/formatter/metadata/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/formatter/req_without_query/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/geoip_providers/common/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/geoip_providers/maxmind/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/health_check/event_sinks/file/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/health_checkers/redis/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/health_checkers/thrift/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/http/cache/file_system_http_cache/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/http/cache/simple_http_cache/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/http/custom_response/local_response_policy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/http/custom_response/redirect_policy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/http/early_header_mutation/header_mutation/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/http/header_formatters/preserve_case/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/http/header_validators/envoy_default/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/http/injected_credentials/generic/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/http/injected_credentials/oauth2/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/http/original_ip_detection/custom_header/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/http/original_ip_detection/xff/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/http/stateful_session/cookie/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/http/stateful_session/header/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/internal_redirect/allow_listed_routes/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/internal_redirect/previous_routes/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/internal_redirect/safe_cross_scheme/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/key_value/file_based/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/load_balancing_policies/client_side_weighted_round_robin/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/load_balancing_policies/cluster_provided/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/load_balancing_policies/common/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/load_balancing_policies/least_request/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/load_balancing_policies/maglev/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/load_balancing_policies/pick_first/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/load_balancing_policies/random/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/load_balancing_policies/ring_hash/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/load_balancing_policies/round_robin/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/load_balancing_policies/subset/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/load_balancing_policies/wrr_locality/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/matching/common_inputs/environment_variable/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/matching/common_inputs/network/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/matching/common_inputs/ssl/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/matching/input_matchers/consistent_hashing/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/matching/input_matchers/ip/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/matching/input_matchers/metadata/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/matching/input_matchers/runtime_fraction/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/network/dns_resolver/apple/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/network/dns_resolver/cares/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/network/dns_resolver/getaddrinfo/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/network/socket_interface/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/outlier_detection_monitors/common/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/outlier_detection_monitors/consecutive_errors/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/path/match/uri_template/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/path/rewrite/uri_template/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/quic/connection_debug_visitor/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/quic/connection_id_generator/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/quic/crypto_stream/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/quic/proof_source/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/quic/server_preferred_address/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/rate_limit_descriptors/expr/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/rbac/audit_loggers/stream/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/rbac/matchers/upstream_ip_port/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/regex_engines/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/request_id/uuid/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/resource_monitors/cpu_utilization/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/resource_monitors/downstream_connections/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/resource_monitors/fixed_heap/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/resource_monitors/injected_resource/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/retry/host/omit_canary_hosts/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/retry/host/omit_host_metadata/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/retry/host/previous_hosts/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/retry/priority/previous_priorities/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/router/cluster_specifiers/lua/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/stat_sinks/graphite_statsd/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/stat_sinks/open_telemetry/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/stat_sinks/wasm/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/string_matcher/lua/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/tracers/opentelemetry/resource_detectors/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/tracers/opentelemetry/samplers/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/transport_sockets/alts/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/transport_sockets/http_11_proxy/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/transport_sockets/internal_upstream/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/transport_sockets/proxy_protocol/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/transport_sockets/quic/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/transport_sockets/raw_buffer/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/transport_sockets/s2a/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/transport_sockets/starttls/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/transport_sockets/tap/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/transport_sockets/tcp_stats/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/transport_sockets/tls/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/udp_packet_writer/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/upstreams/http/generic/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/upstreams/http/http/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/upstreams/http/tcp/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/upstreams/http/udp/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/upstreams/http/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/upstreams/tcp/generic/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/upstreams/tcp/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/wasm/v3"
	_ "github.com/cilium/proxy/go/envoy/extensions/watchdog/profile_action/v3"
	_ "github.com/cilium/proxy/go/envoy/service/accesslog/v3"
	_ "github.com/cilium/proxy/go/envoy/service/auth/v3"
	_ "github.com/cilium/proxy/go/envoy/service/cluster/v3"
	_ "github.com/cilium/proxy/go/envoy/service/discovery/v3"
	_ "github.com/cilium/proxy/go/envoy/service/endpoint/v3"
	_ "github.com/cilium/proxy/go/envoy/service/event_reporting/v3"
	_ "github.com/cilium/proxy/go/envoy/service/ext_proc/v3"
	_ "github.com/cilium/proxy/go/envoy/service/extension/v3"
	_ "github.com/cilium/proxy/go/envoy/service/health/v3"
	_ "github.com/cilium/proxy/go/envoy/service/listener/v3"
	_ "github.com/cilium/proxy/go/envoy/service/load_stats/v3"
	_ "github.com/cilium/proxy/go/envoy/service/metrics/v3"
	_ "github.com/cilium/proxy/go/envoy/service/rate_limit_quota/v3"
	_ "github.com/cilium/proxy/go/envoy/service/ratelimit/v3"
	_ "github.com/cilium/proxy/go/envoy/service/redis_auth/v3"
	_ "github.com/cilium/proxy/go/envoy/service/route/v3"
	_ "github.com/cilium/proxy/go/envoy/service/runtime/v3"
	_ "github.com/cilium/proxy/go/envoy/service/secret/v3"
	_ "github.com/cilium/proxy/go/envoy/service/status/v3"
	_ "github.com/cilium/proxy/go/envoy/service/tap/v3"
	_ "github.com/cilium/proxy/go/envoy/service/trace/v3"
	_ "github.com/cilium/proxy/go/envoy/type"
	_ "github.com/cilium/proxy/go/envoy/type/http/v3"
	_ "github.com/cilium/proxy/go/envoy/type/matcher"
	_ "github.com/cilium/proxy/go/envoy/type/matcher/v3"
	_ "github.com/cilium/proxy/go/envoy/type/metadata/v3"
	_ "github.com/cilium/proxy/go/envoy/type/tracing/v3"
	_ "github.com/cilium/proxy/go/envoy/type/v3"
	_ "github.com/cilium/proxy/go/envoy/watchdog/v3"
)
